#include <stdio.h>
#include <stdlib.h>
#include <zlib.h>

#include "menu.h"
#include "gb.h"
#include "integer.h"

uLong sram_crc;

int save_sram(byte *buf,int size)
{
	int ret=1;
	FILE *fp;
	WORD bytes_write=0, write_size = 0;
	const int sram_tbl[]={1,1,1,4,16,8};
	int sram_size = 0x2000 * sram_tbl[size];

	if (rom_get_info()->cart_type>=0x0f && rom_get_info()->cart_type<=0x13){
		int tmp = renderer_get_timer_state();
		memcpy(buf+sram_size, &tmp, sizeof(int));
		sram_size += sizeof(int);
	}

	uLong crc = crc32(0L, Z_NULL, 0);
	crc = crc32(crc, buf, sram_size);
	if (sram_crc == crc)
		return 1;
	
	sprintf(SavePath, "/EMULATOR/RIN/SAVES/%s.SAV", RomName);
 
	if(!(fp = fopen(SavePath, "wb")))
		return 0;
	
	cheat_decreate_cheat_map();
    while (write_size < sram_size){
        bytes_write = fwrite(buf + write_size, 1, 0x200, fp);
        if (bytes_write == 0)
            break;
        write_size += bytes_write;
    }
    
    if(write_size != sram_size)
		ret = 0;

	cheat_create_cheat_map();
	
	fclose(fp);
    
	if(ret)
		sram_crc = crc;
	
	return ret;
}

int load_sram(byte *buf, int bufsize)
{
	FILE *fp;
    long fileSize;
	WORD bytes_read;
	
	memset(buf, 0, bufsize);
	sram_crc = crc32(0L, Z_NULL, 0);
	
	sprintf(SavePath, "/EMULATOR/RIN/SAVES/%s.SAV", RomName);

    if(!(fp = fopen(SavePath, "rb")))
		return 0;

    fseek (fp, 0, SEEK_END);
    fileSize = ftell (fp);
    rewind (fp);
  
	int ramsize=0;
	while(ramsize < fileSize)
	{
        bytes_read = fread(buf + ramsize, 1, 0x200, fp);
		if(bytes_read == 0)
			break;
		ramsize += bytes_read;
	}
	fclose(fp);
	
	if(ramsize & 4)
		renderer_set_timer_state(*(int*)(buf+ramsize-4));
	
	sram_crc = crc32(sram_crc, buf, ramsize);
	
	return ramsize;
}

int save_sate()
{
	FILE *fp;
	WORD bytes_write=0, write_size = 0;
	
	size_t size = gb_save_state(NULL);
	byte *buf = (byte*)malloc(size);
	
	if (!buf)
		return 0;
	
	gb_save_state(buf);
	
	sprintf(SavePath, "/EMULATOR/RIN/SAVES/%s.RST", RomName);
 
	if(!(fp = fopen(SavePath, "wb")))
		return 0;
	
	while (write_size < size){
        bytes_write = fwrite(buf + write_size, 1, 0x200, fp);
        if (bytes_write == 0)
            break;
        write_size += bytes_write;
    }

	fclose(fp);
	return 1;
}

int load_state()
{
	FILE *fp;
	//WORD bytes_write=0, write_size = 0;
	
	sprintf(SavePath, "/EMULATOR/RIN/SAVES/%s.RST", RomName);
 
	if(!(fp = fopen(SavePath, "rb")))
		return 0;

	gb_restore_state(fp,NULL);
	fclose(fp);
	
	if(rom_get_info()->gb_type == 1)
		lcd_set_mpal(0);
	else if(rom_get_info()->gb_type == 2 && sgb_mode)
		lcd_set_mpal(PAL_SGB);
	else
		lcd_set_mpal(setting.gb_palette);
		
	if(rom_get_info()->gb_type>=3 && org_gbtype==3)
		now_gb_mode = 3;
	else if(rom_get_info()->gb_type==2 && sgb_mode)
		now_gb_mode = 2;
	else
		now_gb_mode = 1;
	
	border_uploaded = 2;
	
	return 1;
}
